﻿#pragma once
// #include "gl/Buffer.h"
// #include "gl/Shader.h"
// #include "gl/ShaderProgram.h"


class ShaderProgram;
class Buffer;
class Texture;

struct RectDescr {
	std::optional<glm::vec4> col = std::nullopt;
	glm::vec2 pos = glm::vec2(0);
	glm::vec2 sz = glm::vec2(0);
	glm::vec2 from = glm::vec2(0);
	glm::vec2 to = glm::vec2(0);
	std::optional<Texture*> tex = std::nullopt;
};

struct Drawer2DVert {
	glm::vec2 pos;
	glm::vec2 uv = glm::vec2(1);
	glm::vec4 color = glm::vec4(1,1,1,1);
	int tex_idx = 0;
	bool is_tex_coloured = false;
};

class Drawer2D {
	Buffer* buff;
	float* buff_ptr;
	float* prev_buff_ptr;

	ShaderProgram* shader_prog;

	int vert_cnt = 0;
	int vert_cnt_accum = 0;

public:
	Drawer2D();

	void push_vert(Drawer2DVert v);
	void draw_rect(RectDescr desc);

	void flush_quads();
	void flush_points();

	void reset();
};
