#pragma once
#include "Texture.h"
#include "engine/Engine.h"

struct BuffDesc {
	int byte_len;
	std::optional<void*> upload_data = std::nullopt;
	bool immutable_subdata = true;
	bool mappable_write = false;
	bool mappable_read = false;
	bool persistennt = false;
	bool read_from_shader = true;
	bool write_from_shader = false;
	std::string name = std::string();
};

class Buffer {
public:
  Type type = Type::FLOAT;

	std::string name = std::string();
  uint32_t byte_len = 0;
  uint32_t elem_cnt = 0;
  uint32_t pid = 0;
  uint64_t bindless_address = 0;

  void* data = nullptr;
	char8_t* cpu_data = nullptr;

  void* mapped_buff = nullptr;


	// template<typename T>
	// T operator[](int i) const { return (T)arr[i]; }
 //  T& operator[](int i) { return arr[i]; }

  // Buffer(void* data, int byte_len);
  // Buffer(std::optional<void*> data, int byte_len);
	Buffer( BuffDesc desc );
  void bind_as_SSBO(int idx);
  void bind_as_MDI_buff();
  void bind_as_indirect_compute_buff();
  void bind_as_MDI_PARAM_buff();

  void upload_sub_data(void* data, int byte_len, int byte_offs = 0);

  void set_name(std::string_view _name);


  void flush();
	void clear();
	void destroy();
};
