#pragma once
#include "WDumbMap.h"


enum class ShaderType {
  Fragment = GL_FRAGMENT_SHADER,
	Compute = GL_COMPUTE_SHADER,
  Vertex = GL_VERTEX_SHADER,
  Geometry = GL_GEOMETRY_SHADER,
};

class ShaderProgram;

class Shader {
private:
	void create();
 public:
  int pid = 0;
  ShaderType shader_type;
  bool compilation_success = false;

	std::vector<ShaderProgram*> shader_programs;
	WDumbMap<SIMDString<>, 32> defines_map;

  std::string_view path;
  std::string code;
  std::string error;

  Shader(std::string_view path, WDumbMap<SIMDString<>, 32> defines_map = WDumbMap<SIMDString<>, 32>());

	Shader* clone_with_new_defines(WDumbMap<SIMDString<>, 32> defines_map);
  void compile();
};
