#include "pch.h"

#include "ShaderManager.h"

#include <codecvt>

#include "Shader.h"
#include "engine/EditorNew.h"
#include "engine/Engine.h"


ShaderManager::ShaderManager() {
	#ifdef EDITOR
	pending_reload_all_shaders.store(false);
	pendingShaderReload.store(false);
	last_shader_change_time.store(0);
	watchFileChanges();
	#endif

	shaders = WArray<Shader*>({}, 100);
	shader_programs = WArray<ShaderProgram*>({}, 100);
}

void ShaderManager::add_shader() {}

void ShaderManager::watchFileChanges() {
	#ifdef EDITOR
	fileWatch = new filewatch::FileWatch<std::wstring>(
		//filewatch::FileWatch<std::wstring> watch(
		L"./src/shaders",
		[this](const std::wstring& path, const filewatch::Event change_type) {
			// std::wcout << path << L" : ";

			long curr_time = clock();
			long prev_shader_change_time = this->last_shader_change_time.load();
			double delta_time_secs = double(curr_time - prev_shader_change_time) / double(CLOCKS_PER_SEC);
			// if(delta_time_secs > 0.15) {
			if (true) {
				this->last_shader_change_time.store(curr_time);
				std::wregex regRules(L".*\\.(frag|vert|comp|geom|glsl)$");

				bool foundReg = std::regex_search(path, regRules);
				if (!foundReg)
					return;
				const bool changedFile = change_type == filewatch::Event::modified ||
					change_type == filewatch::Event::renamed_old;
				// const bool changedFile =  change_type==filewatch::Event::renamed_old;

				if (changedFile) {
					// char* file = new char[path.size()];
					//
					// std::wcstombs(file, path.c_str(), path.size());
					//
					// file[path.size()] = '\0';
					std::wstring_convert<std::codecvt_utf8<wchar_t>> converter;
					std::string str = converter.to_bytes(path);
					for(int i = 0; i < str.size(); i++) {
						if(str[i] == '\\') {
							str[i] = '/';
						}
					}


					shaderReloadMutex.lock();

					this->shadersToReload.push_back(str.c_str());
					if(path.ends_with(L".glsl")) {
						this->pending_reload_all_shaders.store(true);
					}
					// shadersToReload.push_back(file);

					pendingShaderReload.store(true);

					shaderReloadMutex.unlock();
				}

				switch (change_type) {
					// case filewatch::Event::added:
					//	std::cout << "The file was added to the directory." << '\n';
					//	break;
					// case filewatch::Event::removed:
					//	std::cout << "The file was removed from the directory." << '\n';
					//	break;
					// case filewatch::Event::renamed_old:
					//	std::cout << "The file was renamed and this is the old name." <<
					//'\n'; 	break; case filewatch::ChangeType::renamed_new: 	std::cout <<
					//"The file was renamed and this is the new name." << '\n'; 	break;
				};

			}

		});
	#endif
}

// char* ShaderManager::get_shader_code(char* path) {
std::string ShaderManager::get_shader_code(Shader* shader) {
	auto path = shader->path;
	std::string path_conc = "./src/shaders/" + std::string(path);

	std::string include_string;
	std::string shaderString;

	{
		std::ifstream include_file("./src/shaders/include.glsl");
		std::ifstream shader_file(path_conc);
		if (!include_file.is_open() || !shader_file.is_open()) {
			std::cerr << "Error opening files." << std::endl;
			WEngine->editor->finished = true;
		}
		include_string = std::string ((std::istreambuf_iterator<char>(include_file)), std::istreambuf_iterator<char>());
		shaderString = std::string((std::istreambuf_iterator<char>(shader_file)), std::istreambuf_iterator<char>());
		
		include_file.close();
		shader_file.close();
	}

	{
		// Define the regex pattern for #include statements
		// std::regex includePattern(R"#(\s*#include\s+("[^"]+"|<[^>]+>)\s*\n)#");
		// std::regex includePattern(R"#(\s*#include\s+("[^"]+"|<[^>]+>)\s*(\/\/.*)?\n)#");
		std::regex includePattern(R"#(\s*#include\s+(\S+)\s*(\/\/.*)?\n)#");

		// Define a map to store replacement strings for each include
		std::unordered_map<std::string, std::string> replacementMap = {
			{"header1.h", "Replacement1"},
			{"header2.h", "Replacement2"},
			{"header3.h", "Replacement3"}
			// Add more replacements as needed
		};
		// Use a regular loop for replacement
		std::smatch match;
		while (std::regex_search(shaderString, match, includePattern)) {
			// Extract the file name from the match
			std::string fileName = match[1].str();
			fileName = "./src/shaders/" + fileName;


			
			std::string replacement;
			std::ifstream include_file(fileName);
			if(include_file.is_open()) {
				// todo: add err
				replacement = std::string ((std::istreambuf_iterator<char>(include_file)), std::istreambuf_iterator<char>());
			}

			// std::cout << fileName;
			// Find the replacement in the map, or keep the original include if not found
			// auto replacementIt = replacementMap.find(fileName);
			// std::string replacement = (replacementIt != replacementMap.end()) ? replacementIt->second : match.str();

			// Replace the match in the input string
			shaderString = match.prefix().str() + std::string("\n") + replacement + std::string("\n") + match.suffix().str();
		}
		// std::cout << shaderString;

		// // Use std::regex_replace to perform replacements
		// std::string resultString = std::regex_replace(
		// 		shaderString,
		// 		includePattern,
		// 		[&](const std::smatch& match) {
		// 				// Extract the file name from the match
		// 				std::string fileName = match[1].str();
		//
		// 				// Find the replacement in the map, or keep the original include if not found
		// 				auto replacementIt = replacementMap.find(fileName);
		// 				return (replacementIt != replacementMap.end()) ? replacementIt->second : match.str();
		// 		}
		// );
		// // Use std::regex_search to find matches
		// std::sregex_iterator iter(shaderString.begin(), shaderString.end(), includePattern);
		// std::sregex_iterator end;
		//
		// // Loop over matches
		// while (iter != end) {
		// 	for (size_t i = 1; i < iter->size(); ++i) {
		// 		std::cout << "Match found: " << (*iter)[i].str() << std::endl;
		// 	}
		// 	++iter;
		// }
	}

	std::string ret_string = include_string;

	ret_string += "\n";
	for (int i = 0; i < shader->defines_map.sz; i++) {
		auto define = shader->defines_map[i];
		auto define_key = shader->defines_map.keys[i];
		ret_string += "#define ";
		ret_string += define_key.c_str();
		ret_string += " ";
		ret_string += define.c_str();
		ret_string += "\n";
	}
	ret_string += shaderString;
	// ret_string += "\0";

	// char* char_ptr = new char[ret_string.length() + 1]; // +1 for the null terminator
	// std::memcpy(char_ptr, ret_string.c_str(), ret_string.length());
	// char_ptr[ret_string.length()] = '\0';

	return ret_string;
}
