#pragma once

#include "pch.h"


class Shader;
class ShaderProgram;


struct ShaderManager {
  WArray<Shader*> shaders;
  WArray<ShaderProgram*> shader_programs;
	filewatch::FileWatch<std::wstring>* fileWatch;
	std::mutex shaderReloadMutex = std::mutex();
	std::vector<std::string> shadersToReload = std::vector<std::string>();
	std::atomic_bool pendingShaderReload;
	std::atomic_bool pending_reload_all_shaders;
	bool shader_just_reloaded = false;
	std::atomic<long> last_shader_change_time;

  ShaderManager();

  void add_shader();
	void watchFileChanges();
  static std::string get_shader_code(Shader* shader);
};
