﻿#pragma once


template<typename T, int MAX_SZ>
class WDumbMap {
	public:
	int sz = 0;
	SIMDString<32> keys[MAX_SZ];
	T vals[MAX_SZ];

	WDumbMap();

	// typedef const T* iterator;
  // typedef const T* const_iterator;

	using iterator = std::pair<SIMDString<32>&, T&>;
	using const_iterator = std::pair<const SIMDString<32>&, const T&>;

  //iterator _M_array;

  constexpr int size() const noexcept;


	iterator begin() noexcept;
	iterator end() noexcept;

	// const_iterator begin() const noexcept { return const_iterator{keys[0], vals[0]}; }
	// const_iterator end() const noexcept { return const_iterator{keys[sz], vals[sz]}; }

  // constexpr const_iterator begin(slf) const noexcept { return &self.vals[0]; }
  // constexpr const_iterator end(slf) const noexcept { return &self.vals[sz]; }

	T operator[](int i) const;
	T& operator[](int i);

	void set(slf, const char* key, T val);

	T& get(slf,const char* key);

	bool contains(slf, const char* key);

};

template <typename T, int MAX_SZ>
WDumbMap<T, MAX_SZ>::WDumbMap() {

}

template <typename T, int MAX_SZ>
constexpr int WDumbMap<T, MAX_SZ>::size() const noexcept { return sz; }

template <typename T, int MAX_SZ>
typename WDumbMap<T, MAX_SZ>::iterator WDumbMap<T, MAX_SZ>::begin() noexcept { return iterator{keys[0], vals[0]}; }

template <typename T, int MAX_SZ>
typename WDumbMap<T, MAX_SZ>::iterator WDumbMap<T, MAX_SZ>::end() noexcept { return iterator{keys[sz], vals[sz]}; }

template <typename T, int MAX_SZ>
T WDumbMap<T, MAX_SZ>::operator[](int i) const { return this->vals[i]; }

template <typename T, int MAX_SZ>
T& WDumbMap<T, MAX_SZ>::operator[](int i) { return this->vals[i]; }

template <typename T, int MAX_SZ>
void WDumbMap<T, MAX_SZ>::set(this auto&& self, const char* key, T val) {
	bool found = false;

	int i = 0;
	for(; i < self.sz; i++) {
		if(self.keys[i] == key) {
			found = true;
		}
	}
	if(found) {
		self.vals[i] = val;
	} else {
		i = self.sz++;
		self.vals[i] = val;
		self.keys[i] = key;
	}
}

template <typename T, int MAX_SZ>
T& WDumbMap<T, MAX_SZ>::get(this auto&& self, const char* key) {
	int i = 0;
	for(; i < self.sz; i++) {
		if(self.keys[i] == key) {
			return self.vals[i];
			// found = true;
		}
	}
	// return T;
}

template <typename T, int MAX_SZ>
bool WDumbMap<T, MAX_SZ>::contains(this auto&& self, const char* key) {
	bool found = false;
	int i = 0;
	for(; i < self.sz; i++) {
		if(self.keys[i] == key) {
			found = true;
		}
	}
	return found;
}
