#include "pch.h"


extern "C" {
	__declspec(dllexport) unsigned long NvOptimusEnablement = 1;
	__declspec(dllexport) int AmdPowerXpressRequestHighPerformance = 1;
}


#ifdef DISTRIB
	#pragma comment(linker, "/subsystem:windows")
#else
	#pragma comment(lib, "DbgHelp.lib")
	#include "../LivePP/API/x64/LPP_API_x64_CPP.h"
#endif DISTRIB


#include "engine/Engine.h"
#include "gl/WGL.h"



WLog* Globals::log = nullptr;
Engine* Globals::engine = nullptr;
Globals* Globals::global = nullptr;
void* Globals::lppAgent = nullptr;





#ifdef TRACY_ENABLE
void* operator new(std::size_t count) {
	auto ptr = malloc(count);
	TracyAlloc(ptr, count);
	return ptr;
}

void operator delete(void* ptr) noexcept {
	TracyFree(ptr);
	std::free(ptr);
}

void* operator new[](std::size_t count) {
	auto ptr = malloc(count);
	TracyAlloc(ptr, count);
	return ptr;
}

void operator delete[](void* ptr) noexcept {
	TracyFree(ptr);
	free(ptr);
}

void* operator new(std::size_t count, const std::nothrow_t&) noexcept {
	auto ptr = malloc(count);
	TracyAlloc(ptr, count);
	return ptr;
}

void operator delete(void* ptr, const std::nothrow_t&) noexcept {
	TracyFree(ptr);
	free(ptr);
}

void* operator new[](std::size_t count, const std::nothrow_t&) noexcept {
	auto ptr = malloc(count);
	TracyAlloc(ptr, count);
	return ptr;
}

void operator delete[](void* ptr, const std::nothrow_t&) noexcept
{
	TracyFree(ptr);
	std::free(ptr);
}
// 	void* operator new(std::size_t count){
// 		void* ptr = malloc(count);
// 		TracyAlloc(ptr, count);
// 		return ptr;
// 	}
// 	void operator delete(void* ptr) noexcept{
// 		TracyFree(ptr);
// 		free(ptr);
// 	}
//
// void* operator new[](std::size_t count) {
// 	auto ptr = std::malloc(count);
// 	TracyAlloc(ptr, count);
// 	return ptr;
// }
//
// void operator delete[](void* ptr) noexcept {
// 	TracyFree(ptr);
// 	std::free(ptr);
// }


uint64_t mem_usage_jolt_bytes = 0;

// Your custom memory allocation function
void* MyAllocate(size_t inSize) {
	// Implement your memory allocation logic here
	// Example: using new for simplicity, replace with your custom allocator
	mem_usage_jolt_bytes += inSize;
	void* ptr = new char[inSize];
	return ptr;
}

// Your custom memory deallocation function
void MyFree(void* inBlock) {
	// Implement your memory deallocation logic here
	// Example: using delete for simplicity, replace with your custom deallocator
	// mem_usage_jolt_bytes -= inBlock;
	// TracyFree(inBlock);
	delete[] static_cast<char*>(inBlock);
}

// Your custom aligned memory allocation function
void* MyAlignedAllocate(size_t inSize, size_t inAlignment) {
	// Implement your aligned memory allocation logic here
	// Example: using aligned_alloc for simplicity, replace with your custom allocator
	// return aligned_alloc(inAlignment, inSize);
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';
	std::cout << "alloc" << '\n';

	void* ptr = _aligned_malloc(inSize, inAlignment);
	TracyAlloc(ptr, inSize);
	return ptr;
}

// Your custom aligned memory deallocation function
void MyAlignedFree(void* inBlock) {
	// Implement your aligned memory deallocation logic here
	// Example: using free for simplicity, replace with your custom deallocator
	TracyFree(inBlock);
	_aligned_free(inBlock);
}
#endif


// Assign your custom functions to the Jolt library's function pointers
// JPH::AllocateFunction Allocate;
// JPH::FreeFunction Free;
// JPH::AlignedAllocateFunction AlignedAllocate;
// JPH::AlignedFreeFunction AlignedFree;

#include "vlc/vlc.h"


int main(int argc, char* argv[]) {
	// HMODULE giflib = LoadLibrary("giflib.dll");
	
	// const char *_argv[] = {
	// 	"--no-xlib", 
	// 	"--no-video-title-show"
	// };
	// int _argc = sizeof(_argv) / sizeof(*_argv);
	// auto vlc = libvlc_new(_argc, _argv);


	Globals::log = new WLog();

	#ifdef DISTRIB
		Globals::log->disable_logging();
	#endif

	
	// JPH::RegisterDefaultAllocator();

 // Allocate = MyAllocate;
 // Free = MyFree;
 // AlignedAllocate = MyAlignedAllocate;
 // AlignedFree = MyAlignedFree;


	#ifdef TRACY_ENABLE
	JPH::RegisterCustomAllocator( MyAllocate, MyFree, MyAlignedAllocate, MyAlignedFree );
	#else
	JPH::RegisterDefaultAllocator();
	#endif


	#ifdef LIVEPP_ENABLED
	if (true) {
	 std::wstring live_pp_path = L"LivePP";
   lpp::LppSynchronizedAgent lppAgent =
       lpp::LppCreateSynchronizedAgent(nullptr, live_pp_path.c_str());
 
	 // bail out in case the agent is not valid
         if (!lpp::LppIsValidSynchronizedAgent(&lppAgent))
	 {
	 	return 1;
	 }
   Globals::lppAgent = &lppAgent;
 
	 // enable Live++ for all loaded modules
	 lppAgent.EnableModule(lpp::LppGetCurrentModulePath(), lpp::LPP_MODULES_OPTION_ALL_IMPORT_MODULES, nullptr, nullptr);
  }
	#endif
	// create a default agent, loading the Live++ agent from the given path, e.g. "ThirdParty/LivePP"



	Globals::global = new Globals();
	Engine* engine = new Engine();


	// auto audio_mixer = AudioMixer();
	// auto physics = Physics();

	wlog_info("-- ENGINE INIT FINISHED --");


	glBindVertexArray(WEngine->wgl->vao);

	// engine->run();
	// engine->run_b();
	engine->run();


	ExitProcess(0);
};
