﻿#include "pch.h"
// #include "Light.h"
// #include "WAlloc.h"
#include "engine/Camera.h"
#include "engine/Engine.h"
#include "engine/Gif.h"
#include "engine/Video.h"
#include "engine/audio/AudioMixer.h"
#include "gl/Framebuffer.h"
#include "gl/Shader.h"
#include "gl/ShaderManager.h"
#include "gl/WGL.h"


Lane* seq_amogus;
Curve curve_posoomba;
Curve curve_posoomba5;	
Curve curve_posoomba4;	
Curve curve_posoomba7;	
Lane* seq_agoomba;
Curve curve_agoomba;
Lane* seq_blorgus;
Lane* seq_blorba;

ShaderProgram* gif_shader_prog;
ShaderProgram* jpg_comp_shader;
ShaderProgram* png_comp_shader;
ShaderProgram* png2_comp_shader;
ShaderProgram* post_shader_prog;
ShaderProgram* compositor_prog;

Framebuffer* jpg_result_framebuffer;
Framebuffer* gif_result_framebuffer;
Framebuffer* png_result_framebuffer;
Framebuffer* post_process_framebuffer;
Framebuffer* compositor_framebuffer;

Texture* blue_noise_tex;
// Texture* gif_tex;

Buffer* compositor_buff;
Buffer* gif_buff;
Buffer* gif_buff_b;



WGif* giff;
WVideo* vid;
// std::vector<uint8_t> vid_data;


void VarsBruh::init() {
	VarsBruh& v = *this;
	blue_noise_tex = WEngine->alloc_textures.push(std::string("src/assets/images/blue_noise_64_64_RGBA.png")).ptr;

	// giff = new WGif(R"(C:\Users\user\Downloads\nft.gif)");
	giff = new WGif(R"(C:\Users\user\Downloads\001_Arteriovenous_Malformation_MRT_T2_axial.gif)");
	// giff = new WGif(R"(src/assets/revision2025/gifs/Actively_moving_jellyfish_at_Sydney_Aquarium_%28animated%29.gif)");


	// vid = new WVideo(R"(file:///C:\Users\user\Downloads\leviathan-debug_0gyKR9HBkN(2).mp4)");
	vid = new WVideo(R"(file:///D:\VJ vids\abstract\pexels-mart-production-7565898.mp4)");
	
	// WVideo* vid = new WVideo(R"(file:///C:\Users\user\Documents\ShareX\Screenshots\2024-01\Ji8DxwB3P8.mp4)");
	// WVideo* vid = new WVideo(R"( file:///C:\Users\user\Downloads\leviathan-debug_0gyKR9HBkN(2).mp4)");
	// vid->playMedia(argv[1]):
		
	v.fb_main = new Framebuffer(FBDesc{
		.textures = {
			WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
		}, .name = "main"
	});
	
  jpg_result_framebuffer = new Framebuffer(FBDesc{
		.textures = {
			WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
		}, .name = "main"
	});
  gif_result_framebuffer = new Framebuffer(FBDesc{
		.textures = {
			WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX/2, .resy = WEngine->RESY/2, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
		}, .name = "main"
	});
  png_result_framebuffer = new Framebuffer(FBDesc{
		.textures = {
			WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
		}, .name = "main"
	});
  compositor_framebuffer = new Framebuffer(FBDesc{
		.textures = {
			WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
		}, .name = "main"
	});
  post_process_framebuffer = new Framebuffer(FBDesc{
		.textures = {
			WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
		}, .name = "main"
	});

	
	seq_amogus = WEngine->editor->timeline.AddSequence("Amogus");
	
	curve_posoomba = seq_amogus->AddCurve("asdg");
	curve_posoomba5 = seq_amogus->AddCurve("gdsfgd");	
	curve_posoomba4 = seq_amogus->AddCurve("gasdgsdd");	
	curve_posoomba7 = seq_amogus->AddCurve("fdddd");	
	seq_agoomba = WEngine->editor->timeline.AddSequence("Agoomba");
	seq_agoomba->AddCurve("dg023512");
	seq_blorgus = WEngine->editor->timeline.AddSequence("Blorgus");
	seq_blorgus->AddCurve("tgdsgg");
	seq_blorba = WEngine->editor->timeline.AddSequence("Blorba");
	seq_blorba->AddCurve("339kfawsdthj");

	WEngine->editor->timeline.set_json_path("bruh_timeline.json");

	// editor->timeline

	jpg_comp_shader = new ShaderProgram(ShaderProgDescr{
		new Shader("bruh/jpg.comp")
	});
	png_comp_shader = new ShaderProgram(ShaderProgDescr{
		new Shader("bruh/png.comp")
	});
	png2_comp_shader = new ShaderProgram(ShaderProgDescr{
		new Shader("bruh/png2.comp")
	});

	v.prog_render = new ShaderProgram(ShaderProgDescr{
		WEngine->vert_sh_fullscreen_quad,
		new Shader("bruh/default.frag")
	});
	
	gif_shader_prog = new ShaderProgram(ShaderProgDescr{
		WEngine->vert_sh_fullscreen_quad,
		new Shader("bruh/gif.frag")
	});
	
	
	post_shader_prog = new ShaderProgram(ShaderProgDescr{
		WEngine->vert_sh_fullscreen_quad,
		new Shader("bruh/post.frag")
	});
	
	compositor_prog = new ShaderProgram(ShaderProgDescr{
		WEngine->vert_sh_fullscreen_quad,
		new Shader("bruh/compositor.frag")
	});
	
	compositor_buff = new Buffer(BuffDesc{
		.byte_len = 10000, .immutable_subdata = false ,.read_from_shader = true
	});
	// this->buff_indices->upload_sub_data(&indices_array[0], indices_byte_len);
	
	v.render_res_x = WEngine->RESX;
	v.render_res_y = WEngine->RESY;
}

void VarsBruh::loop() {
	VarsBruh& v = *this;
	Engine* e = WEngine;
	ZoneScopedN("LOOP");
	
	if (e->initializing) {
		v.demo_audio = new AudioFile(&e->audio_mixer->engine, "src/assets/sounds/music/wangler.wav");
		v.demo_audio->start();

		e->initializing = false;
	}
	
	// wlog_info("hi this is bruh");	
	static glm::vec3 sun_colour = glm::vec3(1);
	e->editor->add_gui_control("sun colour", &sun_colour, {.is_colour = true});

	e->start_timer_query("test");
	
	// ---- raymarch pass
	{
		e->start_timer_query("raymarch");
		v.fb_main->clear();
		v.fb_main->bind();
		v.prog_render->use();
		v.prog_render->setUniform("u_t", (float)e->time);
		v.prog_render->setUniform("u_bpm", (float)115.0);
		glDrawArrays(GL_TRIANGLES, 0, 6);
	}
	
	// ---- GIF
	{
			e->start_timer_query("gif");
			gif_result_framebuffer->bind();
			gif_result_framebuffer->clear();
			gif_shader_prog->use();
			gif_shader_prog->setUniform("input_tex", v.fb_main->textures[0]);
			gif_shader_prog->setUniform("blue_noise_tex", blue_noise_tex);
			gif_shader_prog->setUniform("output_res",  glm::vec2(
				gif_result_framebuffer->textures[0]->resx,
				gif_result_framebuffer->textures[0]->resy
			));
			glDrawArrays(GL_TRIANGLES, 0, 6);
	}

	// ---- JPG pass
	{
		e->start_timer_query("jpg");
		jpg_comp_shader->use();
		
		jpg_comp_shader->setUniform("input_tex", gif_result_framebuffer->textures[0]);
		jpg_comp_shader->setUniform("jpg_result_tex", jpg_result_framebuffer->textures[0]);
		jpg_comp_shader->dispatch_compute(
			jpg_result_framebuffer->textures[0]->resx,
			jpg_result_framebuffer->textures[0]->resy,
			0
		);
	}
	
	// ---- PNG pass
	// if(true) {
	// 	{
	// 		start_timer_query("png");
	// 		png2_comp_shader->use();
	// 		png2_comp_shader->setUniform("jpg_result_tex", jpg_result_framebuffer->textures[0]);
	// 		png2_comp_shader->setUniform("input_tex", v.fb_main->textures[0]);
	// 		png2_comp_shader->dispatch_compute(
	// 			jpg_result_framebuffer->textures[0]->resx/16,
	// 			jpg_result_framebuffer->textures[0]->resy/16,
	// 			0
	// 		);
	// 	}
	// 	
	// } else {
	// 	{
	// 		start_timer_query("png");
	// 		png_comp_shader->use();
	// 		png_comp_shader->setUniform("jpg_result_tex", jpg_result_framebuffer->textures[0]);
	// 		png_comp_shader->setUniform("input_tex", v.fb_main->textures[0]);
	// 		png_comp_shader->dispatch_compute(
	// 			1,
	// 			jpg_result_framebuffer->textures[0]->resy,
	// 			0
	// 		);
	// 	}
	// }
	{
		
		e->start_timer_query("video upload");

		vid->update();
			// video->buff_idx = (video->buff_idx + 1) % 3;
			// p_pixels[0] = &video->buffer[video->width*video->height*3*video->buff_idx];
		// vid->mutex.lock();
		// 	bool vid_need_update =  vid->needUpdate;
		// 	int vid_idx = (vid->buff_idx  + 3 - 1)%3;
		// vid->mutex.unlock();
		//
		// if(vid_need_update) {
		// 	int buff_offs = vid->width*vid->height*3*vid_idx;
		// 	
		// 	vid->mutex.lock();
		// 		vid->needUpdate = false;
		// 	vid->mutex.unlock();
		// 	// p_pixels[0] = &video->buffer[video->width*video->height*3*video->buff_idx];
		// 	for(int i = 0 ; i < 1080*720; i++) {
		// 		vid_data[i*4 + 0] = vid->buffer[i*3 + 0 + buff_offs];
		// 		vid_data[i*4 + 1] = vid->buffer[i*3 + 1 + buff_offs];
		// 		vid_data[i*4 + 2] = vid->buffer[i*3 + 2 + buff_offs];
		// 		// vid_data[i*4 + 3] = 1;
		// 	}
		// 	// vid->mutex.unlock();
		// 	vid->tex->upload_data(&vid_data[0]);
		// }
		
	}

	giff->render();
	
	{
		{
			int* comp_ptr = (int*)compositor_buff->cpu_data;


			
			// *comp_ptr++ = gif_result_framebuffer->textures[0]->bindless_idx;
			*comp_ptr++ = giff->tex->bindless_idx;
			*comp_ptr++ = 0;
			*(float*)comp_ptr++ = 1;
			*(float*)comp_ptr++ = 1;
			*(float*)comp_ptr++ = 1;
			*(float*)comp_ptr++ = 1;
			*comp_ptr++ = 2;
			compositor_buff->upload_sub_data(compositor_buff->cpu_data, compositor_buff->byte_len);
		}
		e->start_timer_query("composite pass");
		compositor_framebuffer->bind();
		compositor_framebuffer->clear();
		compositor_prog->use();
		compositor_prog->setUniform("composite_commands",compositor_buff);
		compositor_prog->setUniform("commands_cnt",1);
		glDrawArrays(GL_TRIANGLES, 0, 6);
	}

	// ---- Post pass
	{
		e->start_timer_query("post");
		e->default_fb->bind();
		e->default_fb->clear();
		post_shader_prog->use();
		post_shader_prog->setUniform("tex_render", v.fb_main->textures[0]);
		post_shader_prog->setUniform("tex_jpg", jpg_result_framebuffer->textures[0]);
		post_shader_prog->setUniform("tex_gif", gif_result_framebuffer->textures[0]);
		post_shader_prog->setUniform("tex_comp", compositor_framebuffer->textures[0]);
		post_shader_prog->setUniform("tex_vid", vid->tex);
		// post_shader_prog->setUniform("gif_buff", gif_buff);
		// post_shader_prog->setUniform("uindices", gif_buff_b);
		
		// post_shader_prog->setUniform("gif_buff", giff->buff_cols);
		// post_shader_prog->setUniform("uindices", giff->buff_indices);
		post_shader_prog->setUniform("tex_gif_b", giff->tex);
		
		// gif_buff
		
		glDrawArrays(GL_TRIANGLES, 0, 6);
	}

	e->start_timer_query("end");
	
	// v.fb_main->bind();
	// v.fb_main->clear();


	// glMemoryBarrier(GL_ALL_BARRIER_BITS);
	// glTextureBarrier();

	// v.fb_main->blit(default_fb);

}
