﻿#include "pch.h"
// #include "Light.h"
// #include "WAlloc.h"
#include "engine/Camera.h"
#include "engine/Engine.h"
#include "gl/Framebuffer.h"
#include "gl/Shader.h"
#include "gl/ShaderManager.h"


void VarsReSTIR::init() {
		VarsReSTIR& v = *this;
		WEngine->camera->noclip = true;
	
		v.frame = 0;
		v.prog_clean_dbg = new ShaderProgram(
			{
				new Shader("engine/clean_dbg.comp")
			}
		);

		// v.hdri_tex = WEngine->alloc_textures.push(std::string("src/assets/hdri/aristea_wreck_puresky_4k.hdr")).ptr;
		v.hdri_tex = WEngine->alloc_textures.push(std::string("src/assets/hdri/table_mountain_split.hdr")).ptr;
	
		v.font = new Font(std::string("Vintage_Stylist.otf"));



	
		v.fb_hdri_prefiltered = new Framebuffer(FBDesc{
			.textures = { v.hdri_tex->clone() }, ._pongable = false, .autopong = false, .name = "HDRI prefiltered"
		});
		v.fb_ReSTIR = new Framebuffer(FBDesc{
			.textures = {WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
				}, ._pongable = true, .autopong = true, .name = "Restir A"
		});
		v.fb_ReSTIRB = new Framebuffer(FBDesc{
			.textures = {WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
				}, ._pongable = true, .autopong = true, .name = "Restir B"
		});
	
		v.fb_atrous = new Framebuffer(FBDesc{
			.textures = {WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
			}, ._pongable = true, .autopong = false, .name = "Atrous"
		});

		v.fb_SVGF_var = new Framebuffer(FBDesc{
			.textures = {WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr
				}, ._pongable = true, .autopong = true, .name = "Restir B"
		});
	
	
		v.fb_PT = new Framebuffer(FBDesc{
			.textures = {WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::READ
			}).ptr
				}, ._pongable = true, .autopong = true, .name = "PT"
		});
		v.fb_G = new Framebuffer(FBDesc{
			.textures = {
				WEngine->alloc_textures.push(TextureDesc{
					.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
					.internal_format = InternalFormat::RGBA16F, .tex_access = TexAccess::READ
				}).ptr,
				WEngine->alloc_textures.push(TextureDesc{
					.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
					.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::READ
				}).ptr
				}, ._pongable = true, .autopong = true,
			.depth_texture = WEngine->alloc_textures.push(TextureDesc{WEngine->RESX, WEngine->RESY, 1u, v.depth_format}).ptr,
			.name = "G"
		});
		v.fb_Post = new Framebuffer(FBDesc{
			.textures = {WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr}, .name = "Post"
		});
	
		v.fb_var_temp = new Framebuffer(FBDesc{
			.textures = {WEngine->alloc_textures.push(TextureDesc{
				.resx = WEngine->RESX, .resy = WEngine->RESY, .resz = 1,
				.internal_format = InternalFormat::RGBA32F, .tex_access = TexAccess::RW
			}).ptr}, .name = "Var temp"
		});

		// v.prog_vox = new ShaderProgram(ShaderProgDescr{
		// 	new Shader("cloud_tracer/vox.comp")
		// });
		v.prog_gbuff = new ShaderProgram({
			WEngine->vert_sh_fullscreen_quad,
			new Shader("scene_restir/g_buff.frag")
		});
		v.prog_render = new ShaderProgram(ShaderProgDescr{
			WEngine->vert_sh_fullscreen_quad,
			new Shader("scene_restir/render.frag")
		});
		v.prog_post = new ShaderProgram(ShaderProgDescr{
			WEngine->vert_sh_fullscreen_quad,
			new Shader("scene_restir/post.frag")
		});
	
		v.prog_svgf_var = new ShaderProgram(ShaderProgDescr{
			WEngine->vert_sh_fullscreen_quad,
			new Shader("scene_restir/svgf_var.frag")
		});
		v.prog_hdri_prefilter = new ShaderProgram(ShaderProgDescr{
			WEngine->vert_sh_fullscreen_quad,
			new Shader("scene_restir/hdri_prefilter.frag")
		});
	
	
		v.prog_atrous = new ShaderProgram(ShaderProgDescr{
			WEngine->vert_sh_fullscreen_quad,
			new Shader("scene_restir/atrous.frag")
		});
		v.prog_var_preblur = new ShaderProgram(ShaderProgDescr{
			WEngine->vert_sh_fullscreen_quad,
			new Shader("scene_restir/var_preblur.frag")
		});
	
		// v.tex_vox = WEngine->alloc_textures.push(vox_tex_desc).ptr;
		// v.tex_voxb = WEngine->alloc_textures.push(vox_tex_desc).ptr;
		// v.tex_voxc = WEngine->alloc_textures.push(vox_tex_desc).ptr;

		v.tex_blue_noise = WEngine->alloc_textures.push(std::string("src/assets/images/blue_noise_64_64_RGBA.png")).ptr;
	
}

void VarsReSTIR::loop() {
	VarsReSTIR& v = *this;
	Engine* e = WEngine;
	
	ZoneScopedN("LOOP");
	// Sleep(1000);
	// this->startFrame();

	glDisable(GL_BLEND);

	e->camera->speed = 0.3;
	e->camera->_far = 200.0;

	static bool temporal_restir = true;
	static bool reset_cam_on_move = false;

	
	if (e->initializing) {
		ZoneScopedN("re-init");
		wlog_info("-- RE-INITIALIZING -- ");
		e->camera->pos = glm::vec3(0.062, 0.0, 1.181);

		e->initializing = false;
	}

	v.frame++;
	

	e->start_timer_query("clean dbg");
	{
		v.prog_clean_dbg->use();
		v.prog_clean_dbg->dispatch_compute(1, 1, 1);
		glMemoryBarrier(GL_ALL_BARRIER_BITS);
		v.dbg_tex->clear();
	}
	// ------------------------------- //
	// ---------- GAME LOGIC --------- //
	// ------------------------------- //
	{
		ZoneScopedN("GAME LOGIC");

		e->editor->gui_dbg_print("mouse ndc", e->io->mouse_ndc);
	}


	// ------------------------------- //
	// ----------- RENDER ----------- //
	// ------------------------------- //
	{
		ZoneScopedN("RENDER COMMANDS");
		e->start_timer_query("frame_start");

		// ------------- RENDER ------------ //
		// ------------- RENDER ------------ //
		// ------------- RENDER ------------ //
		// ------------- RENDER ------------ //
		// ------------- RENDER ------------ //
		// ------------- RENDER ------------ //

		glMemoryBarrier(GL_ALL_BARRIER_BITS);

		
		e->editor->add_gui_control("reset cam on move", &reset_cam_on_move);
		e->editor->add_gui_control("temporal_restir", &temporal_restir);
		e->editor->add_gui_control("taa jitt", &e->camera->taa_jitt_amt);

		glDisable(GL_CULL_FACE);
		glDisable(GL_DEPTH_TEST);

		bool to_reset = false;
		
		if(
			(e->camera->camera_moved_this_frame && reset_cam_on_move) || e->shader_manager->shader_just_reloaded) {
			to_reset = true;
		}
		
		if(to_reset) {
			v.fb_ReSTIR->clear_back();
			v.fb_ReSTIR->clear();
			v.fb_ReSTIRB->clear_back();
			v.fb_ReSTIRB->clear();
			v.fb_PT->clear_back();
			v.frame = 1;
		}

		// this->camera->fov = 
		e->editor->add_gui_control("can_fov", &e->camera->fov);


		
		// ------ HDRI prefilter ----- //
		{
			e->start_timer_query("hdri prefilter");
			ZoneScopedN("hdri prefilter");

			v.fb_hdri_prefiltered->bind();
			v.fb_hdri_prefiltered->clear();

			v.prog_hdri_prefilter->use();
			v.prog_hdri_prefilter->setUniform("hdri_tex", v.hdri_tex);
			
			glDrawArrays(GL_TRIANGLES, 0, 6);
			v.fb_hdri_prefiltered->get_front_textures_at(0)->generate_mipmap();
		}

		
		glEnable(GL_DEPTH_TEST);
		// ------ GBUFF ----- //
		{
			e->start_timer_query("gbuff");
			ZoneScopedN("gbuff");
		
			v.fb_G->bind();
			v.fb_G->clear();
			v.prog_gbuff->use();
			// v.prog_render->setUniform("vox_tex", v.tex_vox);
			v.prog_gbuff->setUniform("frame", v.frame);
			// v.prog_render->setUniform("restir_tex", v.fb_ReSTIR->get_front_textures_at(0));
			// v.prog_render->setUniform("restir_tex_b", v.fb_ReSTIRB->get_front_textures_at(0));
			// v.prog_render->setUniform("restir_tex_prev", v.fb_ReSTIR->get_back_textures_at(0));
			// v.prog_render->setUniform("restir_tex_b_prev", v.fb_ReSTIRB->get_back_textures_at(0));
			// v.prog_gbuff->setUniform("pt_prev_frame", v.fb_PT->get_back_textures_at(0));
			v.prog_gbuff->setUniform("blue_noise_tex", v.tex_blue_noise);
			v.prog_gbuff->setUniform("hdri_tex", v.hdri_tex);
			glDrawArrays(GL_TRIANGLES, 0, 6);
		}
		
		glDisable(GL_DEPTH_TEST);

		// ------ ReSTIR ----- //
		{
			e->start_timer_query("render");
			ZoneScopedN("Render");

			// for (auto shader : this->shader_manager->shader_programs) {

			v.fb_PT->bind();
			v.fb_PT->clear();
			v.prog_render->use();
			// v.prog_render->setUniform("vox_tex", v.tex_vox);
			v.prog_render->setUniform("frame", v.frame);
			v.prog_render->setUniform("restir_tex", v.fb_ReSTIR->get_front_textures_at(0));
			v.prog_render->setUniform("restir_tex_b", v.fb_ReSTIRB->get_front_textures_at(0));
			v.prog_render->setUniform("restir_tex_prev", v.fb_ReSTIR->get_back_textures_at(0));
			v.prog_render->setUniform("restir_tex_b_prev", v.fb_ReSTIRB->get_back_textures_at(0));
			v.prog_render->setUniform("pt_prev_frame", v.fb_PT->get_back_textures_at(0));
			v.prog_render->setUniform("blue_noise_tex", v.tex_blue_noise);
			v.prog_render->setUniform("hdri_tex", v.hdri_tex);
			v.prog_render->setUniform("hdri_tex_filtered", v.fb_hdri_prefiltered->get_front_textures_at(0));
			v.prog_render->setUniform("temporal_restir", temporal_restir);

			v.prog_render->setUniform("g_buff_depth", v.fb_G->get_front_depth());
			v.prog_render->setUniform("g_buff_depth_prev", v.fb_G->get_back_depth());
			v.prog_render->setUniform("g_buff_tex_a", v.fb_G->get_front_textures_at(0));
			v.prog_render->setUniform("g_buff_tex_b", v.fb_G->get_front_textures_at(1));
			v.prog_render->setUniform("g_buff_tex_a_prev", v.fb_G->get_back_textures_at(0));
			v.prog_render->setUniform("g_buff_tex_b_prev", v.fb_G->get_back_textures_at(1));
			glDrawArrays(GL_TRIANGLES, 0, 6);

			// glMemoryBarrier(GL_ALL_BARRIER_BITS);
			// glTextureBarrier();
		}
		
		// ------ SVGF var calc ----- //
		{
			e->start_timer_query("SVGF var calc");
			ZoneScopedN("SVGF var calc");
			v.fb_SVGF_var->bind();
			v.fb_SVGF_var->clear();

			v.prog_svgf_var->use();
			v.prog_svgf_var->setUniform("g_buff_depth", v.fb_G->get_front_depth());
			v.prog_svgf_var->setUniform("g_buff_depth_prev", v.fb_G->get_back_depth());
			v.prog_svgf_var->setUniform("g_buff_tex_a", v.fb_G->get_front_textures_at(0));
			v.prog_svgf_var->setUniform("g_buff_tex_b", v.fb_G->get_front_textures_at(1));
			v.prog_svgf_var->setUniform("g_buff_tex_a_prev", v.fb_G->get_back_textures_at(0));
			v.prog_svgf_var->setUniform("g_buff_tex_b_prev", v.fb_G->get_back_textures_at(1));
			
			v.prog_svgf_var->setUniform("svgf_tex_prev", v.fb_SVGF_var->get_back_textures_at(0));
			v.prog_svgf_var->setUniform("pt_tex", v.fb_PT->get_front_textures_at(0));
			
			glDrawArrays(GL_TRIANGLES, 0, 6);
		}

		// ------ SVGF var blur ----- //
		{
			v.fb_var_temp->bind();
			v.fb_var_temp->clear();
			
			v.prog_var_preblur->use();
			v.prog_var_preblur->setUniform("svgf_tex", v.fb_SVGF_var->get_front_textures_at(0));
			
			
			glDrawArrays(GL_TRIANGLES, 0, 6);
		}
		
		
		// ------ Atrous calc ----- //
		{
			e->start_timer_query("atrous");
			ZoneScopedN("atrous");
			int atr_iters = 4;
			
			v.prog_atrous->use();
			
			v.prog_atrous->setUniform("var_tex_in", v.fb_var_temp->get_front_textures_at(0));
			v.prog_atrous->setUniform("g_buff_depth", v.fb_G->get_front_depth());
			v.prog_atrous->setUniform("g_buff_depth_prev", v.fb_G->get_back_depth());
			v.prog_atrous->setUniform("g_buff_tex_a", v.fb_G->get_front_textures_at(0));
			v.prog_atrous->setUniform("g_buff_tex_b", v.fb_G->get_front_textures_at(1));
			v.prog_atrous->setUniform("g_buff_tex_a_prev", v.fb_G->get_back_textures_at(0));
			v.prog_atrous->setUniform("g_buff_tex_b_prev", v.fb_G->get_back_textures_at(1));
			
			v.prog_atrous->setUniform("svgf_tex", v.fb_SVGF_var->get_front_textures_at(0));
			v.prog_atrous->setUniform("pt_tex", v.fb_PT->get_front_textures_at(0));
			
			for(int i = 0; i < atr_iters; i++) {
				v.fb_atrous->pong();
				v.fb_atrous->bind();
				v.fb_atrous->clear();
				
				v.prog_atrous->setUniform("atrous_tex_prev", v.fb_atrous->get_back_textures_at(0));
				v.prog_atrous->setUniform("iter", i);
				
				glDrawArrays(GL_TRIANGLES, 0, 6);
			}

		}
		
		// v.fb_atrous = new Framebuffer(FBDesc{
		// ------ Post ----- //
		{
			e->start_timer_query("post");
			ZoneScopedN("Post");

			// for (auto shader : this->shader_manager->shader_programs) {

			v.fb_Post->bind();
			v.fb_Post->clear();

			v.prog_post->use();
			v.prog_post->setUniform("frame", v.frame);
			v.prog_post->setUniform("render_tex", v.fb_PT->get_front_textures_at(0));
			v.prog_post->setUniform("atrous_tex", v.fb_atrous->get_front_textures_at(0));

			glDrawArrays(GL_TRIANGLES, 0, 6);

			glMemoryBarrier(GL_ALL_BARRIER_BITS);
			glTextureBarrier();
		}
		v.fb_Post->blit(e->default_fb);

		// hdri_tex->generate_mipmap();

		// v.prev_frame_gi_tex->clear();
	}

	// ------ End ----- //
	{
		ZoneScopedN("END RENDER");
		e->start_timer_query("frame_end");
		// editor->depth_texture = v.fb_G->get_front_depth();
		// this->endFrame();
	}

	{
		ZoneScopedN("MORE END OF RENDER");
		// audio_mixer->update_player(camera->pos, camera->dir, v.player->get_vel() * 10.0f);

		e->drawer_3d->reset();
		e->drawer_2d->reset();
		// text_drawer->reset_end_of_frame();

	}

}

