﻿#pragma once

struct VarsReSTIR : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;
	
	Font* font;

	Texture* dbg_tex;
	InternalFormat depth_format = InternalFormat::DEPTH_COMPONENT24;
	InternalFormat gi_internal_format = InternalFormat::R11F_G11F_B10F;

	// Framebuffer* fb_vox;
	Texture* tex_blue_noise;
	Texture* hdri_tex;
	Framebuffer* fb_G;
	Framebuffer* fb_PT;
	Framebuffer* fb_SVGF_var;
	Framebuffer* fb_atrous;
	Framebuffer* fb_var_temp;
	Framebuffer* fb_hdri_prefiltered;
	Framebuffer* fb_ReSTIR;
	Framebuffer* fb_ReSTIRB;
	Framebuffer* fb_Post;

	ShaderProgram* prog_gbuff;
	ShaderProgram* prog_vox;
	ShaderProgram* prog_render;
	ShaderProgram* prog_post;
	ShaderProgram* prog_clean_dbg;
	ShaderProgram* prog_svgf_var;
	ShaderProgram* prog_hdri_prefilter;
	ShaderProgram* prog_var_preblur;
	ShaderProgram* prog_atrous;
	
	int frame = 0;
	
	void init() override;
	void loop() override;
};


struct VarsRevision2024 : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;
	
	Font* font;

	Texture* dbg_tex;
	InternalFormat depth_format = InternalFormat::DEPTH_COMPONENT24;
	InternalFormat gi_internal_format = InternalFormat::RGBA16F;

	Buffer* buff;
	// Framebuffer* fb_vox;
	Texture* tex_blue_noise;
	Texture* hdri_tex;
	
	Texture* img_r;
	Texture* img_g;
	Texture* img_b;
	
	Framebuffer* fb_PT;
	Framebuffer* fb_Post;

	ShaderProgram* prog_render;
	ShaderProgram* prog_post;
	ShaderProgram* prog_clean_dbg;
	
	int frame = 0;
	void init() override;
	void loop() override;
};


struct VarsFlameDOF : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;
	
	Font* font;

	Texture* dbg_tex;
	
	InternalFormat flame_internal_format = InternalFormat::RGBA32F;

	Texture* tex_blue_noise;
	Texture* dof_tex;
	
	Texture* img_r;
	Texture* img_g;
	Texture* img_b;
	
	Framebuffer* fb_Post;

	ShaderProgram* prog_render;
	ShaderProgram* prog_post;
	ShaderProgram* prog_clean_dbg;
	
	int frame = 0;
	
	void init() override;
	void loop() override;
};

struct VarsTreeParticles : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;
	
	// Font* font;
	Texture* dbg_tex;
	
	InternalFormat flame_internal_format = InternalFormat::RGBA32F;

	Texture* tex_blue_noise;
	Texture* splat_tex;
	// Texture* dof_tex;
	
	// Texture* img_r;
	// Texture* img_g;
	// Texture* img_b;
	Buffer* tree_buff;
	Buffer* particles_buff;
	Buffer* particles_free_slots_buff;
	
	Framebuffer* fb_Post;

	ShaderProgram* prog_fill_tree;
	ShaderProgram* prog_clean_tree;
	ShaderProgram* prog_spawn_particles;
	ShaderProgram* prog_simulate;
	ShaderProgram* prog_render;
	ShaderProgram* prog_post;
	ShaderProgram* prog_clean_dbg;
	
	void init() override;
	void loop() override;
};

struct VarsRevision2025 : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;

	AudioFile* demo_audio;
	Texture* dbg_tex;
	InternalFormat depth_format = InternalFormat::DEPTH_COMPONENT24;
	InternalFormat gi_internal_format = InternalFormat::R11F_G11F_B10F;

	// Framebuffer* fb_vox;
	
	Texture* noise_tex;
	Texture* tex_vox;
	Texture* tex_voxb;
	Texture* tex_voxc;
	Texture* tex_blue_noise;
	Texture* hdri_tex;
	Framebuffer* fb_GI;
	Framebuffer* fb_Post;

	
	ShaderProgram* prog_render_noise;
	ShaderProgram* prog_vox;
	ShaderProgram* prog_render;
	ShaderProgram* prog_post;
	ShaderProgram* prog_clean_dbg;
	void init() override;
	void loop() override;
};

struct VarsBruh : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;

	AudioFile* demo_audio;

	Font* font;

	Texture* dbg_tex;

	Framebuffer* fb_main;

	ShaderProgram* prog_render;
	void init() override;
	void loop() override;
};

struct VarsPathtrace : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;

	AudioFile* demo_audio;

	Font* font;

	Texture* dbg_tex;

	Framebuffer* fb_main;

	ShaderProgram* prog_render;
	void init() override;
	void loop() override;
};

struct VarsExegfx : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;
	Font* font;
	Texture* dbg_tex;
	Framebuffer* fb_main;
	void init() override;
	void loop() override;
};

struct VarsOpflow : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;
	Font* font;
	Texture* dbg_tex;
	Framebuffer* fb_main;
	void init() override;
	void loop() override;
};


struct VarsCat : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;

	// AudioFile* demo_audio;

	Font* font;

	Texture* dbg_tex;

	// Framebuffer* fb_main;

	// ShaderProgram* prog_render;
	void init() override;
	void loop() override;
};

struct VarsAbstractExpressionism : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;

	// AudioFile* demo_audio;

	Font* font;

	Texture* dbg_tex;

	// Framebuffer* fb_main;

	// ShaderProgram* prog_render;
	void init() override;
	void loop() override;
};

struct VarsStippling : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;

	// AudioFile* demo_audio;

	Font* font;

	Texture* dbg_tex;

	// Framebuffer* fb_main;

	// ShaderProgram* prog_render;
	void init() override;
	void loop() override;
};

struct VarsNordlicht24 : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;

	// AudioFile* demo_audio;

	Font* font;

	Texture* dbg_tex;

	// Framebuffer* fb_main;

	// ShaderProgram* prog_render;
	void init() override;
	void loop() override;
};

struct VarsRadianceCache : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;
	
	Font* font;

	Texture* dbg_tex;
	InternalFormat depth_format = InternalFormat::DEPTH_COMPONENT24;
	InternalFormat gi_internal_format = InternalFormat::R11F_G11F_B10F;

	// Framebuffer* fb_vox;
	Texture* tex_blue_noise;
	Texture* hdri_tex;
	Framebuffer* fb_G;
	Framebuffer* fb_PT;
	Framebuffer* fb_SVGF_var;
	Framebuffer* fb_atrous;
	Framebuffer* fb_var_temp;
	Framebuffer* fb_hdri_prefiltered;
	Framebuffer* fb_ReSTIR;
	Framebuffer* fb_ReSTIRB;
	Framebuffer* fb_Post;

	ShaderProgram* prog_gbuff;
	ShaderProgram* prog_vox;
	ShaderProgram* prog_render;
	ShaderProgram* prog_post;
	ShaderProgram* prog_clean_dbg;
	ShaderProgram* prog_svgf_var;
	ShaderProgram* prog_hdri_prefilter;
	ShaderProgram* prog_var_preblur;
	ShaderProgram* prog_atrous;
	
	int frame = 0;
	
	void init() override;
	void loop() override;
};

struct VarsRevision2024B : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;

	AudioFile* demo_audio;
	Texture* dbg_tex;
	InternalFormat depth_format = InternalFormat::DEPTH_COMPONENT24;
	InternalFormat gi_internal_format = InternalFormat::R11F_G11F_B10F;

	// Framebuffer* fb_vox;
	
	Texture* noise_tex;
	Texture* tex_vox;
	Texture* tex_voxb;
	Texture* tex_voxc;
	Texture* tex_blue_noise;
	Texture* hdri_tex;
	Framebuffer* fb_GI;
	Framebuffer* fb_Post;

	
	ShaderProgram* prog_render_noise;
	ShaderProgram* prog_vox;
	ShaderProgram* prog_render;
	ShaderProgram* prog_post;
	ShaderProgram* prog_clean_dbg;
	
	void init() override;
	void loop() override;
};

struct VarsCloudTracer : public Scene {
	uint32_t render_res_x;
	uint32_t render_res_y;

	Texture* dbg_tex;
	InternalFormat depth_format = InternalFormat::DEPTH_COMPONENT24;
	InternalFormat gi_internal_format = InternalFormat::R11F_G11F_B10F;

	// Framebuffer* fb_vox;
	LUT* lut;
	
	Texture* noise_tex;
	Texture* tex_vox;
	Texture* tex_voxb;
	Texture* tex_voxc;
	Texture* tex_blue_noise;
	Texture* hdri_tex;
	Texture* tex_cloud_shadow_map;
	Framebuffer* fb_GI;
	Framebuffer* fb_Post;

	
	ShaderProgram* prog_bsm;
	ShaderProgram* prog_render_noise;
	ShaderProgram* prog_vox;
	ShaderProgram* prog_render;
	ShaderProgram* prog_post;
	ShaderProgram* prog_clean_dbg;
	
	void init() override;
	void loop() override;
};
struct StartMenuB;

struct VarsGGJ : public Scene{
	bool compute_subdiv = false;
	bool add_prev_di_and_gi = true;
	int tex_anchor = 0;
	float camrot_speed = 1.0;

	WObj<WEntity> ico_object;
	ModelNode* prefab_ico;
	Light* light_sun;

	float dist_since_footstep = 0.0;
	int footstep_idx = 0;
	AudioFile* audio_footsteps[5];

	AudioFile* audio_ost;
	
	AudioFile* audio_bababooey;
	AudioFile* audio_vineboom;
	AudioFile* audio_huhcat;
	AudioFile* audio_metalpipe;
	
	// std::vector<AudioFile*> audio_files;

	const float player_speed = 2.;
	float t_since_player_jump = 10.0;
	float crouching_amt = 0.0f;

	Level level;

	WObj<WEntity> carrying_object;
	WObj<WEntity> trippy_obj;


	StartMenuB* start_menu;
	ModelNode* prefab_player;
	ModelNode* prefab_enemy;
	
	glm::vec3 player_start_pos;
	WEntity* player;

	Texture* eye_open_tex;
	Texture* eye_closed_tex;
	Texture* hdri_tex;
	Texture* dbg_tex;
	Font* font;

	uint32_t render_res_x;
	uint32_t render_res_y;
	InternalFormat depth_format = InternalFormat::DEPTH_COMPONENT24;
	InternalFormat gi_internal_format = InternalFormat::R11F_G11F_B10F;
	Framebuffer* fb_G;
	Framebuffer* fb_GI;
	Framebuffer* fb_GI_plus_DI;
	Framebuffer* fb_DI;
	Framebuffer* fb_GI_reproj;
	Framebuffer* fb_taa;
	Texture* prev_frame_gi_tex;

	ShaderProgram* prog_trippy;
	ShaderProgram* prog_taa;
	ShaderProgram* prog_post;
	ShaderProgram* prog_thing;
	ShaderProgram* prog_gi_reproj;
	ShaderProgram* prog_add_gi_and_di;
	ShaderProgram* prog_gi_comp;
	ShaderProgram* prog_di;
	ShaderProgram* prog_clean_dbg;

	int potato = 5;

	ModelNode* block_prefab;

	glm::ivec2 player_facing_dir = glm::ivec2(1,0);
	glm::ivec2 player_pos = glm::ivec2(0,0);
	bool dead = false;
	bool finished_level_screen = false;
	bool intro_screen = true;
	int intro_segment = 0;
	
	void init() override;
	void loop() override;
};

struct Vars{
	bool compute_subdiv = false;
	bool add_prev_di_and_gi = true;
	int tex_anchor = 0;
	float camrot_speed = 1.0;

	WObj<WEntity> ico_object;
	ModelNode* prefab_ico;
	Light* light_sun;

	float dist_since_footstep = 0.0;
	int footstep_idx = 0;
	AudioFile* audio_footsteps[5];
	AudioFile* audio_pickup;
	AudioFile* audio_obj_fall;
	std::vector<glm::vec3> audio_positions;
	std::vector<AudioFile*> audio_files;

	const float player_speed = 2.;
	float score = 0.0;
	float t_since_player_jump = 10.0;
	float t_since_walljump = 10.0;
	float crouching_amt = 0.0f;

	WObj<WEntity> carrying_object;
	WObj<WEntity> trippy_obj;


	StartMenu* start_menu;
	ModelNode* prefab_player;
	glm::vec3 player_start_pos;
	WEntity* player;

	Texture* hdri_tex;
	Texture* dbg_tex;
	Font* font;

	uint32_t render_res_x;
	uint32_t render_res_y;
	InternalFormat depth_format = InternalFormat::DEPTH_COMPONENT24;
	InternalFormat gi_internal_format = InternalFormat::R11F_G11F_B10F;
	Framebuffer* fb_G;
	Framebuffer* fb_GI;
	Framebuffer* fb_GI_plus_DI;
	Framebuffer* fb_DI;
	Framebuffer* fb_GI_reproj;
	Framebuffer* fb_taa;
	Texture* prev_frame_gi_tex;

	ShaderProgram* prog_trippy;
	ShaderProgram* prog_taa;
	ShaderProgram* prog_post;
	ShaderProgram* prog_thing;
	ShaderProgram* prog_gi_reproj;
	ShaderProgram* prog_add_gi_and_di;
	ShaderProgram* prog_gi_comp;
	ShaderProgram* prog_di;
	ShaderProgram* prog_clean_dbg;

	int potato = 5;
};
